Add form control
Link form control with cell
In the above example, you may have found that the form control can be linked with a cell. When the value of the form control changes, the cell will also change. This can be done using the following code.
Form controls with no value such as a button, label, group box, etc. cannot be linked to cells.
Bind event
You can listen to the buttonClicked or valueChanged event of the form control.
UI Behavior
Usually, a left mouse button click means interacting with the form control.
In order to select the form control for moving or resizing, you can use ctrl + left mouse click or right mouse click.
window.onload = function () {
var workbook = new GC.Spread.Sheets.Workbook(document.getElementById("ss"));
workbook.suspendPaint();
initSheet1(workbook.getSheet(0));
workbook.resumePaint();
};
function initSheet1(sheet) {
setData(sheet);
setStyle(sheet);
setFormControl(sheet);
}
function setData(sheet) {
var departmentData = ["Sales", "Editorial", "Research", "HR", "Finance", "Product", "Marketing", "Purchasing"];
for (var i = 0; i < departmentData.length; i++) {
sheet.setValue(i, 12, departmentData[i]);
}
sheet.setValue(1, 2, "liming");
sheet.setArray(21, 0, [
["name", "age", "gender", "like", null, "department"],
[null, null, null, "basketball", "football", null],
]);
sheet.setArray(23, 0, [["=C2", "=C3", '=CHOOSE(A20, "male", "female")', '=IF(C20,"yes","no")', '=IF(D20, "yes", "no")', "=INDEX(M1:M8,B20)"]], true);
sheet.setArray(0, 13, [
["item1", 67],
["item2", 159],
["item3", 177],
["item4", 93],
["item5", 166],
["item6", 91],
["item7", 57],
["item8", 107],
["item9", 92],
["item10", 175],
]);
for (var i = 1; i <= 6; i++) {
sheet.setFormula(i, 7, "=INDEX(N" + i + ":N10, P1)");
sheet.setFormula(i, 8, "=INDEX(O" + i + ":O10, P1)");
}
}
function setStyle(sheet) {
sheet.defaults.colWidth = 70;
sheet.setColumnWidth(5, 80);
sheet.getRange(1, 0, 13, 5).backColor("#bdd7ee");
sheet.getRange(21, 0, 2, 6).backColor("#bdd7ee");
sheet.getRange(1, 2, 1, 2).hAlign(1);
sheet.getRange(21, 0, 3, 6).hAlign(1);
sheet.getRange(21, 0, 3, 6).vAlign(1);
sheet.addSpan(1, 2, 1, 2);
sheet.addSpan(21, 3, 1, 2);
sheet.addSpan(21, 0, 2, 1);
sheet.addSpan(21, 1, 2, 1);
sheet.addSpan(21, 2, 2, 1);
sheet.addSpan(21, 5, 2, 1);
sheet.conditionalFormats.addDataBarRule(
GC.Spread.Sheets.ConditionalFormatting.ScaleValueType.automin,
null,
GC.Spread.Sheets.ConditionalFormatting.ScaleValueType.automax,
null,
"green",
[new GC.Spread.Sheets.Range(1, 8, 6, 1)]
);
}
function setFormControl(sheet) {
var shapes = sheet.shapes;
var nameLabel = shapes.addFormControl("name", GC.Spread.Sheets.Shapes.FormControlType.label, 84, 20, 55, 20);
nameLabel.text("name:");
var ageLabel = shapes.addFormControl("age", GC.Spread.Sheets.Shapes.FormControlType.label, 96, 40, 55, 20);
ageLabel.text("age:");
var ageSpinBtn = shapes.addFormControl("spin", GC.Spread.Sheets.Shapes.FormControlType.spinButton, 210, 40, 70, 26);
var options = ageSpinBtn.options();
(options.cellLink = "C3"), (options.minValue = 1);
options.maxValue = 120;
ageSpinBtn.options(options);
ageSpinBtn.value(18);
var genderGroupBox = shapes.addFormControl("gender", GC.Spread.Sheets.Shapes.FormControlType.groupBox, 70, 80, 210, 60);
genderGroupBox.text("gender");
var male = shapes.addFormControl("male", GC.Spread.Sheets.Shapes.FormControlType.optionButton, 90, 105, 90, 20);
male.text("male");
male.value(true);
var female = shapes.addFormControl("female", GC.Spread.Sheets.Shapes.FormControlType.optionButton, 180, 105, 90, 20);
female.text("female");
options = female.options();
(options.cellLink = "A20"), female.options(options);
var likeGroupBox = shapes.addFormControl("like", GC.Spread.Sheets.Shapes.FormControlType.groupBox, 70, 160, 210, 60);
likeGroupBox.text("like");
var basketball = shapes.addFormControl("basketball", GC.Spread.Sheets.Shapes.FormControlType.checkBox, 90, 185, 90, 20);
basketball.text("basketball");
options = basketball.options();
(options.cellLink = "C20"), basketball.options(options);
var football = shapes.addFormControl("football", GC.Spread.Sheets.Shapes.FormControlType.checkBox, 180, 185, 90, 20);
football.text("football");
options = football.options();
(options.cellLink = "D20"), football.options(options);
var departmentLabel = shapes.addFormControl("department label", GC.Spread.Sheets.Shapes.FormControlType.label, 69, 240, 80, 20);
departmentLabel.text("department:");
var department = shapes.addFormControl("department", GC.Spread.Sheets.Shapes.FormControlType.comboBox, 150, 240, 130, 20);
options = department.options();
options.cellLink = "B20";
options.inputRange = "M1:M8";
options.dropDownLines = 5;
department.options(options);
department.value(1);
var scrollBar = shapes.addFormControl("scroll bar", GC.Spread.Sheets.Shapes.FormControlType.scrollBar, 642, 21, 24, 116);
options = scrollBar.options();
options.cellLink = "P1";
options.minValue = 1;
options.maxValue = 5;
scrollBar.options(options);
scrollBar.value(1);
var listBox = shapes.addFormControl("listBox", GC.Spread.Sheets.Shapes.FormControlType.listBox, 500, 200, 180, 100);
options = listBox.options();
options.cellLink = "B20";
options.inputRange = "M1:M8";
listBox.options(options);
var button = shapes.addFormControl("button", GC.Spread.Sheets.Shapes.FormControlType.button, 500, 380, 160, 100);
button.text("Click me");
sheet.bind(GC.Spread.Sheets.Events.FormControlButtonClicked, function (s, args) {
alert("button clicked...");
});
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/purejs/node_modules/@mescius/spread-sheets-shapes/dist/gc.spread.sheets.shapes.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
</div>
</body>
</html>
input[type="text"] {
width: 200px;
margin-right: 20px;
}
label {
display: inline-block;
width: 110px;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
label {
display: block;
margin-bottom: 6px;
}
input {
padding: 4px 6px;
}
input[type=button] {
margin-top: 6px;
display: block;
width:216px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
code {
border: 1px solid #000;
}

Add form control
Link form control with cell
In the above example, you may have found that the form control can be linked with a cell. When the value of the form control changes, the cell will also change. This can be done using the following code.
Form controls with no value such as a button, label, group box, etc. cannot be linked to cells.
Bind event
You can listen to the buttonClicked or valueChanged event of the form control.
UI Behavior
Usually, a left mouse button click means interacting with the form control.
In order to select the form control for moving or resizing, you can use ctrl + left mouse click or right mouse click.
<template>
<div class="sample-tutorial">
<gc-spread-sheets hostClass="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet></gc-worksheet>
</gc-spread-sheets>
</div>
</template>
<script setup>
import GC from "@mescius/spread-sheets";
import { ref } from "vue";
import "@mescius/spread-sheets-vue";
import '@mescius/spread-sheets-shapes';
const spreadRef = ref(null);
const initSpread = (spread) => {
spreadRef.value = spread;
spread.suspendPaint();
let sheet = spread.getSheet(0);
setData(sheet);
setStyle(sheet);
setFormControl(sheet);
spread.resumePaint();
}
function setData(sheet) {
let departmentData = ["Sales", "Editorial", "Research", "HR", "Finance", "Product", "Marketing", "Purchasing"];
for (let i = 0; i < departmentData.length; i++) {
sheet.setValue(i, 12, departmentData[i]);
}
sheet.setValue(1, 2, "liming");
sheet.setArray(21, 0, [
["name", "age", "gender", "like", null, "department"],
[null, null, null, "basketball", "football", null],
]);
sheet.setArray(23, 0, [["=C2", "=C3", '=CHOOSE(A20, "male", "female")', '=IF(C20,"yes","no")', '=IF(D20, "yes", "no")', "=INDEX(M1:M8,B20)"]], true);
sheet.setArray(0, 13, [
["item1", 67],
["item2", 159],
["item3", 177],
["item4", 93],
["item5", 166],
["item6", 91],
["item7", 57],
["item8", 107],
["item9", 92],
["item10", 175],
]);
for (let i = 1; i <= 6; i++) {
sheet.setFormula(i, 7, "=INDEX(N" + i + ":N10, P1)");
sheet.setFormula(i, 8, "=INDEX(O" + i + ":O10, P1)");
}
}
function setStyle(sheet) {
sheet.defaults.colWidth = 70;
sheet.setColumnWidth(5, 80);
sheet.getRange(1, 0, 13, 5).backColor("#bdd7ee");
sheet.getRange(21, 0, 2, 6).backColor("#bdd7ee");
sheet.getRange(1, 2, 1, 2).hAlign(1);
sheet.getRange(21, 0, 3, 6).hAlign(1);
sheet.getRange(21, 0, 3, 6).vAlign(1);
sheet.addSpan(1, 2, 1, 2);
sheet.addSpan(21, 3, 1, 2);
sheet.addSpan(21, 0, 2, 1);
sheet.addSpan(21, 1, 2, 1);
sheet.addSpan(21, 2, 2, 1);
sheet.addSpan(21, 5, 2, 1);
sheet.conditionalFormats.addDataBarRule(
GC.Spread.Sheets.ConditionalFormatting.ScaleValueType.automin,
null,
GC.Spread.Sheets.ConditionalFormatting.ScaleValueType.automax,
null,
"green",
[new GC.Spread.Sheets.Range(1, 8, 6, 1)]
);
}
function setFormControl(sheet) {
let shapes = sheet.shapes;
let nameLabel = shapes.addFormControl("name", GC.Spread.Sheets.Shapes.FormControlType.label, 84, 20, 55, 20);
nameLabel.text("name:");
let ageLabel = shapes.addFormControl("age", GC.Spread.Sheets.Shapes.FormControlType.label, 96, 40, 55, 20);
ageLabel.text("age:");
let ageSpinBtn = shapes.addFormControl("spin", GC.Spread.Sheets.Shapes.FormControlType.spinButton, 210, 40, 70, 26);
let options = ageSpinBtn.options();
(options.cellLink = "C3"), (options.minValue = 1);
options.maxValue = 120;
ageSpinBtn.options(options);
ageSpinBtn.value(18);
let genderGroupBox = shapes.addFormControl("gender", GC.Spread.Sheets.Shapes.FormControlType.groupBox, 70, 80, 210, 60);
genderGroupBox.text("gender");
let male = shapes.addFormControl("male", GC.Spread.Sheets.Shapes.FormControlType.optionButton, 90, 105, 90, 20);
male.text("male");
male.value(true);
let female = shapes.addFormControl("female", GC.Spread.Sheets.Shapes.FormControlType.optionButton, 180, 105, 90, 20);
female.text("female");
options = female.options();
(options.cellLink = "A20"), female.options(options);
let likeGroupBox = shapes.addFormControl("like", GC.Spread.Sheets.Shapes.FormControlType.groupBox, 70, 160, 210, 60);
likeGroupBox.text("like");
let basketball = shapes.addFormControl("basketball", GC.Spread.Sheets.Shapes.FormControlType.checkBox, 90, 185, 90, 20);
basketball.text("basketball");
options = basketball.options();
(options.cellLink = "C20"), basketball.options(options);
let football = shapes.addFormControl("football", GC.Spread.Sheets.Shapes.FormControlType.checkBox, 180, 185, 90, 20);
football.text("football");
options = football.options();
(options.cellLink = "D20"), football.options(options);
let departmentLabel = shapes.addFormControl("department label", GC.Spread.Sheets.Shapes.FormControlType.label, 69, 240, 80, 20);
departmentLabel.text("department:");
let department = shapes.addFormControl("department", GC.Spread.Sheets.Shapes.FormControlType.comboBox, 150, 240, 130, 20);
options = department.options();
options.cellLink = "B20";
options.inputRange = "M1:M8";
options.dropDownLines = 5;
department.options(options);
department.value(1);
let scrollBar = shapes.addFormControl("scroll bar", GC.Spread.Sheets.Shapes.FormControlType.scrollBar, 642, 21, 24, 116);
options = scrollBar.options();
options.cellLink = "P1";
options.minValue = 1;
options.maxValue = 5;
scrollBar.options(options);
scrollBar.value(1);
let listBox = shapes.addFormControl("listBox", GC.Spread.Sheets.Shapes.FormControlType.listBox, 500, 200, 180, 100);
options = listBox.options();
options.cellLink = "B20";
options.inputRange = "M1:M8";
listBox.options(options);
let button = shapes.addFormControl("button", GC.Spread.Sheets.Shapes.FormControlType.button, 500, 380, 160, 100);
button.text("Click me");
sheet.bind(GC.Spread.Sheets.Events.FormControlButtonClicked, function (s, args) {
alert("button clicked...");
});
}
</script>
<style scoped>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
input {
display: inline-block;
}
input[type="text"] {
width: 160px;
}
label {
display: inline-block;
margin-bottom: 6px;
width: 200px;
}
select {
width: 120px;
height: 35px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/inventory-tracker.js" type="text/javascript"></script>
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

Add form control
Link form control with cell
In the above example, you may have found that the form control can be linked with a cell. When the value of the form control changes, the cell will also change. This can be done using the following code.
Form controls with no value such as a button, label, group box, etc. cannot be linked to cells.
Bind event
You can listen to the buttonClicked or valueChanged event of the form control.
UI Behavior
Usually, a left mouse button click means interacting with the form control.
In order to select the form control for moving or resizing, you can use ctrl + left mouse click or right mouse click.
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from "react";
import { SpreadSheets, Worksheet } from "@mescius/spread-sheets-react";
import "@mescius/spread-sheets-shapes";
import GC from "@mescius/spread-sheets";
export function AppFunc() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={(spread) => initWorkbook(spread)}>
<Worksheet></Worksheet>
</SpreadSheets>
</div>
</div>
);
}
function initWorkbook(workbook) {
workbook.suspendPaint();
initSheet1(workbook.getSheet(0));
workbook.resumePaint();
}
function initSheet1(sheet) {
setData(sheet);
setStyle(sheet);
setFormControl(sheet);
}
function setData(sheet) {
var departmentData = ["Sales", "Editorial", "Research", "HR", "Finance", "Product", "Marketing", "Purchasing"];
for (var i = 0; i < departmentData.length; i++) {
sheet.setValue(i, 12, departmentData[i]);
}
sheet.setValue(1, 2, "liming");
sheet.setArray(21, 0, [
["name", "age", "gender", "like", null, "department"],
[null, null, null, "basketball", "football", null],
]);
sheet.setArray(23, 0, [["=C2", "=C3", '=CHOOSE(A20, "male", "female")', '=IF(C20,"yes","no")', '=IF(D20, "yes", "no")', "=INDEX(M1:M8,B20)"]], true);
sheet.setArray(0, 13, [
["item1", 67],
["item2", 159],
["item3", 177],
["item4", 93],
["item5", 166],
["item6", 91],
["item7", 57],
["item8", 107],
["item9", 92],
["item10", 175],
]);
for (var i = 1; i <= 6; i++) {
sheet.setFormula(i, 7, "=INDEX(N" + i + ":N10, P1)");
sheet.setFormula(i, 8, "=INDEX(O" + i + ":O10, P1)");
}
}
function setStyle(sheet) {
sheet.defaults.colWidth = 70;
sheet.setColumnWidth(5, 80);
sheet.getRange(1, 0, 13, 5).backColor("#bdd7ee");
sheet.getRange(21, 0, 2, 6).backColor("#bdd7ee");
sheet.getRange(1, 2, 1, 2).hAlign(1);
sheet.getRange(21, 0, 3, 6).hAlign(1);
sheet.getRange(21, 0, 3, 6).vAlign(1);
sheet.addSpan(1, 2, 1, 2);
sheet.addSpan(21, 3, 1, 2);
sheet.addSpan(21, 0, 2, 1);
sheet.addSpan(21, 1, 2, 1);
sheet.addSpan(21, 2, 2, 1);
sheet.addSpan(21, 5, 2, 1);
sheet.conditionalFormats.addDataBarRule(
GC.Spread.Sheets.ConditionalFormatting.ScaleValueType.automin,
null,
GC.Spread.Sheets.ConditionalFormatting.ScaleValueType.automax,
null,
"green",
[new GC.Spread.Sheets.Range(1, 8, 6, 1)]
);
}
function setFormControl(sheet) {
var shapes = sheet.shapes;
var nameLabel = shapes.addFormControl("name", GC.Spread.Sheets.Shapes.FormControlType.label, 84, 20, 55, 20);
nameLabel.text("name:");
var ageLabel = shapes.addFormControl("age", GC.Spread.Sheets.Shapes.FormControlType.label, 96, 40, 55, 20);
ageLabel.text("age:");
var ageSpinBtn = shapes.addFormControl("spin", GC.Spread.Sheets.Shapes.FormControlType.spinButton, 210, 40, 70, 26);
var options = ageSpinBtn.options();
(options.cellLink = "C3"), (options.minValue = 1);
options.maxValue = 120;
ageSpinBtn.options(options);
ageSpinBtn.value(18);
var genderGroupBox = shapes.addFormControl("gender", GC.Spread.Sheets.Shapes.FormControlType.groupBox, 70, 80, 210, 60);
genderGroupBox.text("gender");
var male = shapes.addFormControl("male", GC.Spread.Sheets.Shapes.FormControlType.optionButton, 90, 105, 90, 20);
male.text("male");
male.value(true);
var female = shapes.addFormControl("female", GC.Spread.Sheets.Shapes.FormControlType.optionButton, 180, 105, 90, 20);
female.text("female");
options = female.options();
(options.cellLink = "A20"), female.options(options);
var likeGroupBox = shapes.addFormControl("like", GC.Spread.Sheets.Shapes.FormControlType.groupBox, 70, 160, 210, 60);
likeGroupBox.text("like");
var basketball = shapes.addFormControl("basketball", GC.Spread.Sheets.Shapes.FormControlType.checkBox, 90, 185, 90, 20);
basketball.text("basketball");
options = basketball.options();
(options.cellLink = "C20"), basketball.options(options);
var football = shapes.addFormControl("football", GC.Spread.Sheets.Shapes.FormControlType.checkBox, 180, 185, 90, 20);
football.text("football");
options = football.options();
(options.cellLink = "D20"), football.options(options);
var departmentLabel = shapes.addFormControl("department label", GC.Spread.Sheets.Shapes.FormControlType.label, 69, 240, 80, 20);
departmentLabel.text("department:");
var department = shapes.addFormControl("department", GC.Spread.Sheets.Shapes.FormControlType.comboBox, 150, 240, 130, 20);
options = department.options();
options.cellLink = "B20";
options.inputRange = "M1:M8";
options.dropDownLines = 5;
department.options(options);
department.value(1);
var scrollBar = shapes.addFormControl("scroll bar", GC.Spread.Sheets.Shapes.FormControlType.scrollBar, 642, 21, 24, 116);
options = scrollBar.options();
options.cellLink = "P1";
options.minValue = 1;
options.maxValue = 5;
scrollBar.options(options);
scrollBar.value(1);
var listBox = shapes.addFormControl("listBox", GC.Spread.Sheets.Shapes.FormControlType.listBox, 500, 200, 180, 100);
options = listBox.options();
options.cellLink = "B20";
options.inputRange = "M1:M8";
listBox.options(options);
var button = shapes.addFormControl("button", GC.Spread.Sheets.Shapes.FormControlType.button, 500, 380, 160, 100);
button.text("Click me");
sheet.bind(GC.Spread.Sheets.Events.FormControlButtonClicked, function (s, args) {
alert("button clicked...");
});
}
import * as React from "react";
import { SpreadSheets, Worksheet } from "@mescius/spread-sheets-react";
import "@mescius/spread-sheets-shapes";
import GC from "@mescius/spread-sheets";
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
}
render() {
return (
<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={(spread) => initWorkbook(spread)}>
<Worksheet></Worksheet>
</SpreadSheets>
</div>
</div>
);
}
}
function initWorkbook(workbook) {
workbook.suspendPaint();
initSheet1(workbook.getSheet(0));
workbook.resumePaint();
}
function initSheet1(sheet) {
setData(sheet);
setStyle(sheet);
setFormControl(sheet);
}
function setData(sheet) {
var departmentData = ["Sales", "Editorial", "Research", "HR", "Finance", "Product", "Marketing", "Purchasing"];
for (var i = 0; i < departmentData.length; i++) {
sheet.setValue(i, 12, departmentData[i]);
}
sheet.setValue(1, 2, "liming");
sheet.setArray(21, 0, [
["name", "age", "gender", "like", null, "department"],
[null, null, null, "basketball", "football", null],
]);
sheet.setArray(23, 0, [["=C2", "=C3", '=CHOOSE(A20, "male", "female")', '=IF(C20,"yes","no")', '=IF(D20, "yes", "no")', "=INDEX(M1:M8,B20)"]], true);
sheet.setArray(0, 13, [
["item1", 67],
["item2", 159],
["item3", 177],
["item4", 93],
["item5", 166],
["item6", 91],
["item7", 57],
["item8", 107],
["item9", 92],
["item10", 175],
]);
for (var i = 1; i <= 6; i++) {
sheet.setFormula(i, 7, "=INDEX(N" + i + ":N10, P1)");
sheet.setFormula(i, 8, "=INDEX(O" + i + ":O10, P1)");
}
}
function setStyle(sheet) {
sheet.defaults.colWidth = 70;
sheet.setColumnWidth(5, 80);
sheet.getRange(1, 0, 13, 5).backColor("#bdd7ee");
sheet.getRange(21, 0, 2, 6).backColor("#bdd7ee");
sheet.getRange(1, 2, 1, 2).hAlign(1);
sheet.getRange(21, 0, 3, 6).hAlign(1);
sheet.getRange(21, 0, 3, 6).vAlign(1);
sheet.addSpan(1, 2, 1, 2);
sheet.addSpan(21, 3, 1, 2);
sheet.addSpan(21, 0, 2, 1);
sheet.addSpan(21, 1, 2, 1);
sheet.addSpan(21, 2, 2, 1);
sheet.addSpan(21, 5, 2, 1);
sheet.conditionalFormats.addDataBarRule(
GC.Spread.Sheets.ConditionalFormatting.ScaleValueType.automin,
null,
GC.Spread.Sheets.ConditionalFormatting.ScaleValueType.automax,
null,
"green",
[new GC.Spread.Sheets.Range(1, 8, 6, 1)]
);
}
function setFormControl(sheet) {
var shapes = sheet.shapes;
var nameLabel = shapes.addFormControl("name", GC.Spread.Sheets.Shapes.FormControlType.label, 84, 20, 55, 20);
nameLabel.text("name:");
var ageLabel = shapes.addFormControl("age", GC.Spread.Sheets.Shapes.FormControlType.label, 96, 40, 55, 20);
ageLabel.text("age:");
var ageSpinBtn = shapes.addFormControl("spin", GC.Spread.Sheets.Shapes.FormControlType.spinButton, 210, 40, 70, 26);
var options = ageSpinBtn.options();
(options.cellLink = "C3"), (options.minValue = 1);
options.maxValue = 120;
ageSpinBtn.options(options);
ageSpinBtn.value(18);
var genderGroupBox = shapes.addFormControl("gender", GC.Spread.Sheets.Shapes.FormControlType.groupBox, 70, 80, 210, 60);
genderGroupBox.text("gender");
var male = shapes.addFormControl("male", GC.Spread.Sheets.Shapes.FormControlType.optionButton, 90, 105, 90, 20);
male.text("male");
male.value(true);
var female = shapes.addFormControl("female", GC.Spread.Sheets.Shapes.FormControlType.optionButton, 180, 105, 90, 20);
female.text("female");
options = female.options();
(options.cellLink = "A20"), female.options(options);
var likeGroupBox = shapes.addFormControl("like", GC.Spread.Sheets.Shapes.FormControlType.groupBox, 70, 160, 210, 60);
likeGroupBox.text("like");
var basketball = shapes.addFormControl("basketball", GC.Spread.Sheets.Shapes.FormControlType.checkBox, 90, 185, 90, 20);
basketball.text("basketball");
options = basketball.options();
(options.cellLink = "C20"), basketball.options(options);
var football = shapes.addFormControl("football", GC.Spread.Sheets.Shapes.FormControlType.checkBox, 180, 185, 90, 20);
football.text("football");
options = football.options();
(options.cellLink = "D20"), football.options(options);
var departmentLabel = shapes.addFormControl("department label", GC.Spread.Sheets.Shapes.FormControlType.label, 69, 240, 80, 20);
departmentLabel.text("department:");
var department = shapes.addFormControl("department", GC.Spread.Sheets.Shapes.FormControlType.comboBox, 150, 240, 130, 20);
options = department.options();
options.cellLink = "B20";
options.inputRange = "M1:M8";
options.dropDownLines = 5;
department.options(options);
department.value(1);
var scrollBar = shapes.addFormControl("scroll bar", GC.Spread.Sheets.Shapes.FormControlType.scrollBar, 642, 21, 24, 116);
options = scrollBar.options();
options.cellLink = "P1";
options.minValue = 1;
options.maxValue = 5;
scrollBar.options(options);
scrollBar.value(1);
var listBox = shapes.addFormControl("listBox", GC.Spread.Sheets.Shapes.FormControlType.listBox, 500, 200, 180, 100);
options = listBox.options();
options.cellLink = "B20";
options.inputRange = "M1:M8";
listBox.options(options);
var button = shapes.addFormControl("button", GC.Spread.Sheets.Shapes.FormControlType.button, 500, 380, 160, 100);
button.text("Click me");
sheet.bind(GC.Spread.Sheets.Events.FormControlButtonClicked, function (s, args) {
alert("button clicked...");
});
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/spread/source/data/data.js" type="text/javascript"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: 100%;
height: 100%;
overflow: hidden;
float: left;
}
input {
padding: 4px 6px;
}
.options-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
label {
display: block;
margin-bottom: 6px;
}
input[type=button] {
margin-top: 6px;
display: block;
width:216px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

Add form control
Link form control with cell
In the above example, you may have found that the form control can be linked with a cell. When the value of the form control changes, the cell will also change. This can be done using the following code.
Form controls with no value such as a button, label, group box, etc. cannot be linked to cells.
Bind event
You can listen to the buttonClicked or valueChanged event of the form control.
UI Behavior
Usually, a left mouse button click means interacting with the form control.
In order to select the form control for moving or resizing, you can use ctrl + left mouse click or right mouse click.
import { Component, NgModule, enableProdMode } from "@angular/core";
import { BrowserModule } from "@angular/platform-browser";
import { FormsModule } from "@angular/forms";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";
import { SpreadSheetsModule } from "@mescius/spread-sheets-angular";
import GC from "@mescius/spread-sheets";
import "@mescius/spread-sheets-shapes";
import "./styles.css";
const spreadNS = GC.Spread.Sheets,
SheetArea = spreadNS.SheetArea;
@Component({
selector: "app-component",
templateUrl: "src/app.component.html",
})
export class AppComponent {
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: "100%",
height: "100%",
overflow: "hidden",
float: "left",
};
constructor() {}
init($event: any) {
let workbook = (this.spread = $event.spread);
initWorkbook(workbook);
}
}
function initWorkbook(workbook: GC.Spread.Sheets.Workbook) {
workbook.suspendPaint();
initSheet1(workbook.getSheet(0));
workbook.resumePaint();
}
function initSheet1(sheet: GC.Spread.Sheets.Worksheet) {
setData(sheet);
setStyle(sheet);
setFormControl(sheet);
}
function setData(sheet: GC.Spread.Sheets.Worksheet) {
var departmentData = ["Sales", "Editorial", "Research", "HR", "Finance", "Product", "Marketing", "Purchasing"];
for (var i = 0; i < departmentData.length; i++) {
sheet.setValue(i, 12, departmentData[i]);
}
sheet.setValue(1, 2, "liming");
sheet.setArray(21, 0, [
["name", "age", "gender", "like", null, "department"],
[null, null, null, "basketball", "football", null],
]);
sheet.setArray(23, 0, [["=C2", "=C3", '=CHOOSE(A20, "male", "female")', '=IF(C20,"yes","no")', '=IF(D20, "yes", "no")', "=INDEX(M1:M8,B20)"]], true);
sheet.setArray(0, 13, [
["item1", 67],
["item2", 159],
["item3", 177],
["item4", 93],
["item5", 166],
["item6", 91],
["item7", 57],
["item8", 107],
["item9", 92],
["item10", 175],
]);
for (var i = 1; i <= 6; i++) {
sheet.setFormula(i, 7, "=INDEX(N" + i + ":N10, P1)");
sheet.setFormula(i, 8, "=INDEX(O" + i + ":O10, P1)");
}
}
function setStyle(sheet: GC.Spread.Sheets.Worksheet) {
sheet.defaults.colWidth = 70;
sheet.setColumnWidth(5, 80);
sheet.getRange(1, 0, 13, 5).backColor("#bdd7ee");
sheet.getRange(21, 0, 2, 6).backColor("#bdd7ee");
sheet.getRange(1, 2, 1, 2).hAlign(1);
sheet.getRange(21, 0, 3, 6).hAlign(1);
sheet.getRange(21, 0, 3, 6).vAlign(1);
sheet.addSpan(1, 2, 1, 2);
sheet.addSpan(21, 3, 1, 2);
sheet.addSpan(21, 0, 2, 1);
sheet.addSpan(21, 1, 2, 1);
sheet.addSpan(21, 2, 2, 1);
sheet.addSpan(21, 5, 2, 1);
sheet.conditionalFormats.addDataBarRule(
GC.Spread.Sheets.ConditionalFormatting.ScaleValueType.automin,
null,
GC.Spread.Sheets.ConditionalFormatting.ScaleValueType.automax,
null,
"green",
[new GC.Spread.Sheets.Range(1, 8, 6, 1)]
);
}
function setFormControl(sheet: GC.Spread.Sheets.Worksheet) {
var shapes = sheet.shapes;
var nameLabel = shapes.addFormControl("name", GC.Spread.Sheets.Shapes.FormControlType.label, 84, 20, 55, 20);
nameLabel.text("name:");
var ageLabel = shapes.addFormControl("age", GC.Spread.Sheets.Shapes.FormControlType.label, 96, 40, 55, 20);
ageLabel.text("age:");
var ageSpinBtn = shapes.addFormControl("spin", GC.Spread.Sheets.Shapes.FormControlType.spinButton, 210, 40, 70, 26);
var options = ageSpinBtn.options();
(options.cellLink = "C3"), (options.minValue = 1);
options.maxValue = 120;
ageSpinBtn.options(options);
ageSpinBtn.value(18);
var genderGroupBox = shapes.addFormControl("gender", GC.Spread.Sheets.Shapes.FormControlType.groupBox, 70, 80, 210, 60);
genderGroupBox.text("gender");
var male = shapes.addFormControl("male", GC.Spread.Sheets.Shapes.FormControlType.optionButton, 90, 105, 90, 20);
male.text("male");
male.value(true);
var female = shapes.addFormControl("female", GC.Spread.Sheets.Shapes.FormControlType.optionButton, 180, 105, 90, 20);
female.text("female");
options = female.options();
(options.cellLink = "A20"), female.options(options);
var likeGroupBox = shapes.addFormControl("like", GC.Spread.Sheets.Shapes.FormControlType.groupBox, 70, 160, 210, 60);
likeGroupBox.text("like");
var basketball = shapes.addFormControl("basketball", GC.Spread.Sheets.Shapes.FormControlType.checkBox, 90, 185, 90, 20);
basketball.text("basketball");
options = basketball.options();
(options.cellLink = "C20"), basketball.options(options);
var football = shapes.addFormControl("football", GC.Spread.Sheets.Shapes.FormControlType.checkBox, 180, 185, 90, 20);
football.text("football");
options = football.options();
(options.cellLink = "D20"), football.options(options);
var departmentLabel = shapes.addFormControl("department label", GC.Spread.Sheets.Shapes.FormControlType.label, 69, 240, 80, 20);
departmentLabel.text("department:");
var department = shapes.addFormControl("department", GC.Spread.Sheets.Shapes.FormControlType.comboBox, 150, 240, 130, 20);
options = department.options();
options.cellLink = "B20";
options.inputRange = "M1:M8";
options.dropDownLines = 5;
department.options(options);
department.value(1);
var scrollBar = shapes.addFormControl("scroll bar", GC.Spread.Sheets.Shapes.FormControlType.scrollBar, 642, 21, 24, 116);
options = scrollBar.options();
options.cellLink = "P1";
options.minValue = 1;
options.maxValue = 5;
scrollBar.options(options);
scrollBar.value(1);
var listBox = shapes.addFormControl("listBox", GC.Spread.Sheets.Shapes.FormControlType.listBox, 500, 200, 180, 100);
options = listBox.options();
options.cellLink = "B20";
options.inputRange = "M1:M8";
listBox.options(options);
var button = shapes.addFormControl("button", GC.Spread.Sheets.Shapes.FormControlType.button, 500, 380, 160, 100);
button.text("Click me");
sheet.bind(GC.Spread.Sheets.Events.FormControlButtonClicked, function (s, args) {
alert("button clicked...");
});
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule {}
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="init($event)">
<gc-worksheet>
</gc-worksheet>
</gc-spread-sheets>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.options-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
input {
padding: 4px 6px;
display: inline-block;
}
input[type="text"] {
width: 200px;
}
label {
display: block;
margin-bottom: 6px;
}
input[type=button] {
margin-top: 6px;
display: block;
width:216px;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-shapes': 'cdn:@mescius/spread-sheets-shapes/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);